// ==========================================================================
// --------------------------------------------------------------------------
// Checksum Fixer
// --------------------------------------------------------------------------

#include <stdio.h>
#include <windows.h>

int main (int ArgNumber, char **ArgList, char **EnvList)

{
	if (ArgNumber <= 0x01)
	{
		printf ("Checksum Fixer (Long-word Version) - by MarkeyJester\n\n -> Arguments are: CheckFix.exe Input.bin\n\n    This tool will use the header information of the ROM to correctly\n    generate the right checksum value\n\nPress enter key to exit...\n");
		getchar ( );
	}
	else
	{
		FILE *File;
		if ((File = fopen (ArgList [0x01], "r+b")) == NULL)
		{
			printf ("CheckFix: Error, could not open %s\n", ArgList [0x01]);
		}
		else
		{
			fseek (File, 0x00, SEEK_END);
			int MemorySize = ftell (File);
			rewind (File);
			char *Memory = (char*) malloc (MemorySize);
			if (Memory == NULL)
			{
				fclose (File);
				printf ("CheckFix: Error, not enough memory\n");
			}
			else
			{
				fread (Memory, 0x01, MemorySize, File);

				int MemoryLoc, CheckSize, CheckValue, CheckWord;

				fseek (File, 0x00, SEEK_END);
				CheckSize = ftell (File);
				fclose (File);
				CheckSize = (CheckSize / 0x04);
				for (MemoryLoc = 0x0000, CheckValue = 0x00; CheckSize > 0x00; CheckSize--)
				{
					if (MemoryLoc != 0x18C)
					{
						CheckWord = (Memory [MemoryLoc++] & 0xFF) << 0x18;
						CheckWord |= (Memory [MemoryLoc++] & 0xFF) << 0x10;
						CheckWord |= (Memory [MemoryLoc++] & 0xFF) << 0x08;
						CheckWord |= Memory [MemoryLoc++] & 0xFF;
						CheckValue += CheckWord;
					}
					else
					{
						MemoryLoc += 0x04;
					}
				}
				free (Memory);
				if ((File = fopen (ArgList [0x02], "wb")) == NULL)
				{
					printf ("CheckFix: Error, could not create %s\n", ArgList [0x01]);
				}
				else
				{
					fputs ("; ===========================================================================", File); fputc (0x0D, File); fputc (0x0A, File);
					fputs ("; ---------------------------------------------------------------------------", File); fputc (0x0D, File); fputc (0x0A, File);
					fputs ("; Generated by \"CheckFix\" - don't bother editing...", File); fputc (0x0D, File); fputc (0x0A, File);
					fputs ("; ---------------------------------------------------------------------------", File); fputc (0x0D, File); fputc (0x0A, File);
					fputc (0x0D, File); fputc (0x0A, File);
					char Text [0x1000];
					snprintf (Text, 0x1000, "CheckValue:	=	$%0.8X", CheckValue);
					fputs (Text, File); fputc (0x0D, File); fputc (0x0A, File);
					fputc (0x0D, File); fputc (0x0A, File);
					fputs ("; ===========================================================================", File); fputc (0x0D, File); fputc (0x0A, File);
					fclose (File);
				}
			}
		}
	}
	return (0x00);
}

// ==========================================================================
